package com.biganto.visual.roompark.presentation.screen.splash

import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.conductor.BigantoBasePresenter
import com.biganto.visual.roompark.domain.interactor.SplashInteractor
import javax.inject.Inject

/**
 * Created by Vladislav Bogdashkin on 30.09.2019.
 */


class SplashScreenPresenter @Inject constructor(
    private val acitivityContext: RoomParkMainActivity
    , private val interactor: SplashInteractor
//    ,var context:Context
)
    : BigantoBasePresenter<SplashScreen, SplashScreenViewState>() {

    override fun bindIntents() {

        val state = restoreStateObservable
            .mergeWith(interactor.getAuth()
                .map {
                    if (it) SplashScreenViewState.ToHomeScreen()
                    else SplashScreenViewState.ToAuthScreen()
                }
            )
        subscribeViewState(state.cast(SplashScreenViewState::class.java), SplashScreen::render)
    }

}