package com.biganto.visual.roompark.util.monades

import androidx.annotation.StringRes
import com.biganto.visual.roompark.domain.custom_exception.CustomApiException

/**
 * Created by Vladislav Bogdashkin on 12.11.2019.
 */

sealed class Either<out E, out V> {
    data class Left<out E>(val left: E) : Either<E, Nothing>()
    data class Right<out V>(val right: V) : Either<Nothing, V>()
}


data class ExceptionString(@StringRes var stringId: Int?, var message: String?) {

    constructor(e:CustomApiException) : this(
        if (e.message!=null) null else e.messageStringId,
        if (e.messageStringId!=null) null else e.message
    )

    init {
        assert(stringId!=null && message!=null) { "both values cannot be non-null" }
        assert(stringId==null && message==null) { "both values cannot be null" }
    }

}